//
//  BluetoothSender.h
//  BTSender
//
//  Created by Sebastian Krauß on 12.10.06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#include <IOBluetooth/IOBluetoothUtilities.h>
#include <IOBluetooth/OBEXBluetooth.h>
#import <IOBluetooth/OBEX.h>
#import <IOBluetooth/objc/IOBluetoothOBEXSession.h>

#import <IOBluetoothUI/objc/IOBluetoothServiceBrowserController.h>
#import <IOBluetooth/objc/IOBluetoothSDPServiceRecord.h>
#import <IOBluetooth/Bluetooth.h>
#import <IOBluetooth/objc/OBEXFileTransferServices.h>


@interface BluetoothSender : NSObject {
    IOBluetoothDevice *device;
    
    IOBluetoothOBEXSession* mOBEXSession;
    id delegate;
    uint32_t totalFilesSizes;
    
    NSMutableArray *files;
    unsigned int currentFileIndex;
    unsigned int totalBytesTransferred;
    
    float lastPercentSent;
    
    NSTimer *connectTimer;
    OBEXFileTransferServices *obexTransfer;
    
    BOOL isConnected;
    BOOL currentlyChangingPath;
    BOOL isFileTransfer;
    BOOL isSending;
    BOOL isConnecting;
}

+ (BOOL)bluetoothAvailableAndPowered;
+ (NSArray*)namesOfDevices;
+ (IOBluetoothDevice*)deviceWithName:(NSString*)deviceName;
+ (BOOL)deviceWithNameSupportsFileTransfer:(NSString*)name;

- (id)initWithDelegate:(id)del;
- (BOOL)prepareFiles:(NSArray*)sendfiles deviceNamed:(NSString*)deviceName;
- (void)sendFiles;
- (void)disconnectFromClient;

- (NSArray*)fileToBeUploaded;
- (void)cancelUpload;
- (void)prepareForDeviceNamed:(NSString*)deviceName;

- (void)openFT;
- (void)getDirectories;
- (void)doGetDirectories;
- (void)changeDirectoryTo:(NSString*)path;
- (void)changeDirectoryUp;
- (void)reallyGetDirectories;
- (BOOL)isSending;
- (BOOL)isConnectingForTransfer;
- (void)doSendNextFile;
- (void)doSendFiles;
- (void)reallySendFiles;
- (void)openOP;
- (void)abort;



@end
