/*
 ****************************
 *         Utilities        *
 *    by widgetschmie.de    *
 ****************************
 */


// opens an URL in the browser
function gotoURL(url) {
	if(window.widget) {
		widget.openURL(url);
	}
}


function clearDisplay(whichDisplay)
{
	var obj = getObj(whichDisplay);
	if (obj == null) return;

	while(obj.lastChild)
	{
		obj.removeChild(obj.lastChild);
	}
}

function displayNumber(where, number) {
	if(isNaN(number))
		return false;
	
	var obj = getObj(where);
	var numberstring = number.toString();
	var strlen = numberstring.length;
	
	// remove old images
	while(obj.lastChild)
		obj.removeChild(obj.lastChild);
	
	// set new images
	for(var i = 0; i < strlen; i++) {
		var thisnum = numberstring.substring(i, i + 1);
		
		var img = document.createElement("img");
		if('.' != thisnum) {
			img.setAttribute("class", "number");
			img.src = "./Images/Digits/" + thisnum + ".png";
		}
		else
			img.src = "./Images/Digits/dot.png";
		obj.appendChild(img);
	}
}

function displayPercent(number) {
	if(isNaN(number))
		return false;
	
	displayNumber('uploadFileProgress', number);
	
	// add the percent-sign
	var img = document.createElement("img");
	img.setAttribute("class", "number");
	img.src = "./Images/Digits/%.png";
	getObj('uploadFileProgress').appendChild(img);
}

function displaySpeed(number) {
	if(isNaN(number))
		return false;
	
	if (number >= 1000)
	{
		if (speedGaugeShowsKBs)
		{
			// shows mb/s
			getObj('uploadSpeedUnity').src = "Images/mbsec.png";
			speedGaugeShowsKBs = false;
		}
		number /= 1024;
	} else {
		if (!speedGaugeShowsKBs)
		{
			// show kb/s
			getObj('uploadSpeedUnity').src = "Images/kbsec.png";
			speedGaugeShowsKBs = true;
		}
	}
	
	var rounded = Math.floor(number * 10) / 10;
	var numberstring = rounded.toString();
	if(rounded == Math.ceil(rounded))
		rounded += ".0";
	
	displayNumber('uploadKBS', rounded);
}


function showPoof(x, y) {
	if(getObj("poof"))
		getObj("poof").parentNode.removeChild(getObj("poof"));
	
	// create the poof
	var my_x = x - 30;
	var my_y = y - 15;
	var div = document.createElement("canvas");
	div.setAttribute("id", "poof");
	div.setAttribute("style", "top:" + my_y + "px; left:" + my_x + "px;");
	div.setAttribute('width', '30');
	div.setAttribute('height', '30');
	
	getObj("back").appendChild(div);
	var poofSound = getObj('poofSound');
	if(poofSound)
		poofSound.Play();
	
	// make sure it animates
	animatePoof(1);
	setTimeout("animatePoof(2)", 100);
	setTimeout("animatePoof(3)", 200);
	setTimeout("animatePoof(4)", 300);
	setTimeout("animatePoof(5)", 400);
	
	// make sure we remove it
	setTimeout("getObj('poof').parentNode.removeChild(getObj('poof'))", 500);
}

function animatePoof(step)
{
	var div = getObj("poof");
	var context = div.getContext("2d");
	context.clearRect(0, 0, 30, 30);
	context.drawImage(poofImage, 0, (step-1)*128, 128, 128, 0, 0, 30, 30);
}



// returns the object, whether you supply an id (string) or an object itself
function getObj(id) {
	var obj;
	if(typeof(id) == "string") {
		obj = getById(id) ? getById(id) : null;
	}
	else if(typeof(id) == "object") {
		obj = id;
	}
	
	return obj;
}

// returns the object with the correspondent ID
function getById(id) {
	if(document.getElementById)
		return document.getElementById(id);
	else if(document.all)
		return document.all[id];
	else
		return false;
}

// cleans a node from its childs
function cleanNode(node) {
	if(typeof(node) != "object") {
		node = getObj(node);
		if(typeof(node) != "object")
			return false;
	}
	
	while(node.firstChild != null) {
		node.removeChild(node.firstChild);
	}
}


function removeKeyFromHash(removeKey, array)
{
	var result = new Object();
	for (var key in array)
	{
		if (key != removeKey) result[key] = array[key];
	}
	return result;
}

function keysFromHash(hash)
{
	var keys = new Array();
	for (var key in hash)
	{
		keys.push(key);
	}
	return keys;
}

function indexOfObjectInArray(array, object)
{
	if("object" != typeof(array)) return -1;
	for (i = 0; i < array.length; i++)
	{
		if (array[i] == object) return i;
	}
	return -1;
}

function inArray(value, arr)
{
	if("object" != typeof(arr)) return false;
	
	for(var i = 0; i < arr.length; i++)
	{
		if(arr[i] == value) return true;
	}
	return false;
}


// selects the preceding input element. Use it for span-objects describing the purpose of a checkbox
function selectVal(clicked) {
	var elem = getObj(clicked);
	while(null != elem.previousSibling) {
		if('input' == elem.previousSibling.nodeName.toLowerCase()) {
			if(! elem.previousSibling.disabled)
				elem.previousSibling.checked = ! elem.previousSibling.checked;
			return;
		}
		elem = elem.previousSibling;
	}
}

// toggles an input-elements "enabled" value
function toggleDisabledIfChecked(check, element) {
	var disable = (getObj(check) && (false == getObj(check).checked));
	var elem = getObj(element);
	
	if(elem) {
		
		// disable main element
		if(('span' == elem.nodeName.toLowerCase()) || ('div' == elem.nodeName.toLowerCase()))
			elem.className = disable ? elem.className.replace(/ *disabled/g, '') + ' disabled' : elem.className.replace(/ *disabled/g, '');
		else
			elem.disabled = disable;
		
		// also disable corresponding Text
		while(null != elem.nextSibling) {
			if(('span' == elem.nextSibling.nodeName.toLowerCase()) && (elem.nextSibling.className && elem.nextSibling.className.match(/clicksel/))) {
				var thisclass = elem.nextSibling.className;
				var newclass = disable ? thisclass.replace(/ *disabled/g, '') + ' disabled' : thisclass.replace(/ *disabled/g, '');
				
				elem.nextSibling.className = newclass;
				return;
			}
			elem = elem.nextSibling;
		}
	}
}

// unchecks an input-element if another gets checked
function uncheckIfChecked(elements, reference) {
	var all_elems = new Array();
	if('string' == typeof(elements))
		all_elems.push(elements);
	else
		all_elems = elements;
	
	var uncheck = (getObj(reference) && (true == getObj(reference).checked));
	if(!uncheck)
		return;
	
	for(var i = 0; i < all_elems.length; i++) {
		var elem = getObj(all_elems[i]);
		
		if(elem) {
			elem.checked = false;
		}
	}
}

// selects a value in a drop-down element
function selectValue(element, value) {
	if(!element) return;
	
	for (i = 0; i < element.length; i++)
	{
		if (element.options[i].value == value)
		{
			element.selectedIndex = i;
			return;
		}
	}
}

function mergeArrays(arrOne, arrTwo) {
	var result = new Array();
	for(var i = 0; i < arrOne.length; i++) {
		result.push(arrOne[i]);
	}
	
	for(var i = 0; i < arrTwo.length; i++) {
		result.push(arrTwo[i]);
	}
	
	return result;
}

function mergeHashes(hashOne, hashTwo)
{
	var result = new Object();
	for (var key in hashOne)
	{
		result[key] = hashOne[key];
	}
	for (var key in hashTwo)
	{
		result[key] = hashTwo[key];
	}
	return result;
}

// returns a SHALLOW copy of a hash
// not appropriate for DEEP copies!
function copyHash(hash)
{
	var result = new Object();
	for (var key in hash)
	{
		result[key] = hash[key];
	}
	return result;
}

function copyArray(array)
{
	var result = new Array();
	for (var i = 0; i < array.length; i++)
	{
		result.push(array[i]);
	}
	return result;
}


function debug(string)
{
	if (!debugMode) return;
	alert(string);
}


// returns the property the browser calculated, if that`s not supported, from the style.
function getComputedValue(prop, obj) {
	var myObj = getObj(obj);
	var getit;
	if(document.defaultView.getComputedStyle)
		getit = document.defaultView.getComputedStyle(myObj, null).getPropertyValue(prop);
	else
		getit = myObj.style[prop];
	
	return getit;
}


function has1043Features() {
	var version = navigator.appVersion;
	var regExp = /.+AppleWebKit\/([\d\.]+).+/;
	var result = regExp.exec(version);
	
	return (parseFloat(result[1]) >= 416.11);
}


// JS serialization

function Serialize(obj) {
    var strSource = "";

    if (typeof(obj) == "undefined") {
        strSource = "undefined";
    }

    else if (obj == null) {
        strSource = "null";
    }

    else if (typeof(obj) == "boolean" || typeof(obj) == "number" || typeof(obj) == "function") {
        strSource = obj;
    }

    else if (typeof(obj) == "string") {
        strSource = "'" + obj.replace(/([\\'"])/g, "\\$1") + "'"; 		//" (just to avoid the texteditors problems with the single Notation Mark)
    }

    else if (typeof(obj) == "object") {
        if (obj.constructor == Boolean) {
            strSource = "new Boolean(" + obj.valueOf() + ")";
        }

        else if (obj.constructor == Number) {
            strSource = "new Number(" + obj.valueOf() + ")";
        }

        else if (obj.constructor == String) {
            strSource = "new String(" + Serialize(obj.toString()) + ")";
        }

        else if (obj.constructor == Date) {
            strSource = "new Date(" + obj.valueOf() + ")";
        }

        else if (obj.constructor == Array) {
            strSource = "[";
            for (var i=0; i<obj.length; i++)
                strSource += Serialize(obj[i]) + ",";
            if (i>0)
                strSource = strSource.substring(0, strSource.length-1);
            strSource += "]";
        }

        else if (obj.constructor == RegExp) {
            strSource = obj.toString();
        }

        else if (obj.constructor == Object) {
            var strSource = "{"
            for (var key in obj)
                strSource = strSource + "" + key + ":" + Serialize(obj[key]) + ","
            if (strSource.length > 1)
                strSource = strSource.substring(0, strSource.length-1);
            strSource += "}";
        }
    }

    else {
        throw new Error(0, "Serialize encountered unexpected object type: " + typeof(obj));
    }

    return strSource;
}


function Deserialize(strSource) {
        if (typeof strSource != "string")
                throw new Error(0, "Deserialize expects a string argument");

        var x;
        return eval("x = " + strSource);
}

